-- twins.ex
-- jiri babor
-- j.babor@gns.cri.nz
-- version 1.00  97-01-30

include graphics.e
include image.e
include font.e
include get.e

constant
   c={1,2,4},                    -- token colors
   rows=13, cols=9,
   true=1,  false=0,
   x0=35,   y0=126,
   dx=65,   dy=24,
   bricks=
  {{6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,6,6,6,6},
   {6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,6,6,6,6},
   {6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,6,6,6,6},
   {6,6,6,8,6,6,6,6,6,8,6,6,6,6,6,6,6,6,6,6},
   {6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,6,6,6,6},
   {6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,4,6,6,6,6},
   {6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,6,6,6,6},
   {6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,6,6,8,6},
   {6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,6,6,6,6},
   {8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,8,6,6,6,6,6,6,8},
   {6,6,8,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,8},
   {8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8}}

atom dt, t
integer aborted, finished, flag, -- general purpose flag
   key, level, n, seed_count,
   mo28, wi12, score, high_score
sequence field, p, pp, seeds, token
object junk

procedure beep(integer freq, atom duration)
   atom t
   sound(freq)
   t=time()
   while time()-t<duration do
   end while
   sound(0)
end procedure

procedure rect(integer c, integer f, sequence s1, sequence s2)
   polygon(c,f,{s1,{s2[1],s1[2]},s2,{s1[1],s2[2]}})
end procedure  -- rect

procedure erase_token(integer r, integer c)
   rect(0,1,{x0+(c-1)*dx,y0+(r-1)*dy},{x0+(c-1)*dx+50,y0+(r-1)*dy+20})
end procedure

procedure get_token_images()
   token={ {{},{},{}}, {{},{},{}}, {{},{},{}} }
   for i = 1 to 3 do
      ellipse(c[i],1,{35,85},{85,100})
      ellipse(c[i]+8,1,{35,81},{85,96})
      token[i][1]=save_image({35,81},{85,100})
      ellipse(c[i],1,{47,85},{73,92})
      draw_line(0,{{55,89},{65,89}})
      draw_line(0,{{52,90},{68,90}})
      draw_line(0,{{52,91},{68,91}})
      draw_line(0,{{55,92},{65,92}})
      token[i][2]=save_image({35,81},{85,100})
      ellipse(c[i],1,{41,83},{79,94})
      token[i][3]=save_image({35,81},{85,100})
   end for
   set_active_page(0)
end procedure

procedure show_high_score()
   display_image({560, 0},bricks)
   display_image({580, 0},bricks)
   display_image({600, 0},bricks)
   display_image({560,20},bricks)
   display_image({580,20},bricks)
   display_image({600,20},bricks)
   fselect(mo28)
   fp[1..3]={1,2,2}           -- char shadows
   ftc=15   fsc=0             -- text & shadow colors
   fx=619   fy=15
   frprint(sprintf("%d",high_score))
end procedure

procedure show_score()
   display_image({560,40},bricks)
   display_image({580,40},bricks)
   display_image({600,40},bricks)
   display_image({560,60},bricks)
   display_image({580,60},bricks)
   display_image({600,60},bricks)
   fselect(mo28)
   fp[1..3]={1,2,2}           -- char shadows
   ftc=15   fsc=0             -- text & shadow colors
   fx=619   fy=45
   frprint(sprintf("%d",score))
end procedure

wi12=fload("wire12.f")
mo28=fload("modern28.f")

procedure brick_wall()
   junk=palette(6,{47,15,7})    -- redefine brown color (bricks)
   junk=palette(8,{31,31,31})    -- redefine dark gray color (mortar)
   for i = 0 to 31 do
      for j = 0 to 5 do
         display_image({20*i,20*j},bricks)
      end for
   end for
   for j = 6 to 23 do
         display_image({0,20*j},bricks)
         display_image({620,20*j},bricks)
   end for
   for i = 1 to 30 do
      for j = 22 to 23 do
         display_image({20*i,20*j},bricks)
      end for
   end for

   -- title
   ellipse( 0,1,{260,25},{330,58})
   ellipse(13,1,{257,22},{327,55})
   ellipse( 5,1,{259,24},{325,53})

   ellipse( 0,1,{205,30},{275,63})
   ellipse(13,1,{202,27},{272,60})
   ellipse( 5,1,{204,29},{270,58})

   ellipse( 0,1,{150,25},{220,58})
   ellipse(13,1,{147,22},{217,55})
   ellipse( 5,1,{149,24},{215,53})

   ellipse( 0,1,{ 95,30},{165,63})
   ellipse(13,1,{ 92,27},{162,60})
   ellipse( 5,1,{ 94,29},{160,58})

   ellipse( 0,1,{ 40,25},{110,58})
   ellipse(13,1,{ 37,22},{107,55})
   ellipse( 5,1,{ 39,24},{105,53})

   fp[1..3]={1,2,2}  -- char shadows
   ftc=15   fsc=0    -- text & shadow colors
   fx=66    fy=28    fprint("T")
   fx=120   fy=31    fprint("w")
   fx=180   fy=28    fprint("i")
   fx=231   fy=31    fprint("n")
   fx=286   fy=28    fprint("s")

   -- scores
   ftc=14
   fx=400   fy=15    fprint("high  score")
   ftc=14
   fx=400   fy=45    fprint("current  score")

   -- clues
   fselect(wi12)
   fp[2..3]={1,1}
   ftc=14   fx=25    fy=449
   fprint({17,#10F} & "  move left")
   ftc=14   fx=25    fy=462
   fprint({16,#10F} & "  move right")
   ftc=14   fx=130   fy=449
   fprint({30,#10F} & "  turn c.w.")
   ftc=14   fx=122   fy=462
   fprint({94,30,#10F} & "  turn a.c.w")
   ftc=14   fx=238   fy=449
   fprint({31,#10F} & "  step")
   ftc=14   fx=230   fy=462
   fprint({94,31,#10F} & "  drop")
   ftc=14   fx=310   fy=449
   fprint("P" & #10F & "ause")
   ftc=14   fx=310   fy=462
   fprint("F1, H" & #10F & "elp")
   ftc=14   fx=380   fy=449
   fprint("space" & #10F & "  flip")
   ftc=14   fx=380   fy=462
   fprint("Esc, Q" & #10F & "uit")

   -- bohemian logo
   ellipse(0,1,{470,450},{610,475})
   ellipse(13,1,{467,447},{607,472})
   ellipse(5,1,{469,449},{605,470})
   fx=509   fy=455   fprint("bohemian")
end procedure

procedure show_pair()
      display_image({x0+(p[1][2]-1)*dx,y0+(p[1][1]-1)*dy},token[p[1][3]][3])
      display_image({x0+(p[2][2]-1)*dx,y0+(p[2][1]-1)*dy},token[p[2][3]][3])
end procedure

procedure show_stone(integer r, integer c, integer sc)   -- solid disk
   display_image({x0+(c-1)*dx,y0+(r-1)*dy},token[sc][1])
end procedure

procedure get_preview_pair()
   rect(0,1,{20,80},{619,109})   -- clear preview window
   pp={rand(7),rand(3),rand(3)}
   display_image({x0+(pp[1]-1)*dx,85},token[pp[2]][3])
   display_image({x0+(pp[1]+1)*dx,85},token[pp[3]][3])
end procedure

procedure game_over()
   ellipse(15,1,{195,227},{445,313})
   ellipse( 5,1,{200,230},{440,310})
   fselect(wi12)
   fp[2..3]={1,1}
   ftc=14
   fx=278   fy=285
   fprint("R" & #10F & "estart     " & #10E & "Q" & #10F & "uit")
   fselect(mo28)
   fp[1..3]={1,2,2}           -- char shadows
   ftc=14
   fy=252
   fcprint(240,400,"Game  Over")
   key=wait_key()
   while key!='r' and key!='q' and key!=27  do
      key=wait_key()
   end while
   if key='q' or key=27 then
      aborted=true
   elsif score>high_score then
      high_score=score
      show_high_score()
   end if
end procedure

procedure get_new_pair()
   if field[1][pp[1]] or field[1][pp[1]+2] then
      finished=true
      game_over()
   else
      p={{1,pp[1],pp[2]},{1,pp[1]+2,pp[3]}}
      show_pair()
      if n<30 then
         n=n+1
      else
         n=0
         dt=dt*0.90
      end if
      get_preview_pair()
   end if
end procedure

procedure sow()
   integer r,c
   rect(0,1,{20,120},{619,439})           -- erase field window
   seeds=repeat(repeat(0,cols+1),rows+1)  -- layer of overscan cells at right
                                          -- and at bottom of field
   seed_count=3*level
   for i = 1 to seed_count do
      r=rows-level+rand(level)
      c=rand(cols)
      while seeds[r][c] do
         r=rows-level+rand(level)
         c=rand(cols)
      end while
      seeds[r][c]=rand(3)
      display_image({x0+(c-1)*dx,y0+(r-1)*dy},token[seeds[r][c]][2])
   end for
   field=seeds

   -- set oversan cells
   for i=1 to rows do
      field[i][cols+1]=1
   end for
   for i=1 to cols do
      field[rows+1][i]=1
   end for

   get_new_pair()
end procedure

procedure init_session()
   aborted=false
   get_token_images()
   brick_wall()
   high_score=0
   show_high_score()
   get_preview_pair()
end procedure

procedure init_game()
   finished=false
   score=0
   show_score()
   level=4
   dt=1.0
   t=time()
   n=0
end procedure

procedure erase_pair()
   rect(0,1,{x0+(p[1][2]-1)*dx,y0+(p[1][1]-1)*dy},{x0+(p[1][2]-1)*dx+50,y0+(p[1][1]-1)*dy+20})
   rect(0,1,{x0+(p[2][2]-1)*dx,y0+(p[2][1]-1)*dy},{x0+(p[2][2]-1)*dx+50,y0+(p[2][1]-1)*dy+20})
end procedure

procedure go_left()
   if p[1][2]>1 and p[2][2]>1 then
      if field[p[1][1]][p[1][2]-1]=0 and field[p[2][1]][p[2][2]-1]=0 then
         erase_pair()
         p[1][2]=p[1][2]-1
         p[2][2]=p[2][2]-1
         show_pair()
      end if
   end if
end procedure

procedure go_right()
   if p[1][2]<cols and p[2][2]<cols then
      if field[p[1][1]][p[1][2]+1]=0 and field[p[2][1]][p[2][2]+1]=0 then
         erase_pair()
         p[1][2]=p[1][2]+1
         p[2][2]=p[2][2]+1
         show_pair()
      end if
   end if
end procedure

procedure flip()
   integer dummy
   erase_pair()
   dummy=p[1][3]
   p[1][3]=p[2][3]
   p[2][3]=dummy
   show_pair()
end procedure

procedure turn_clockwise()
   integer dummy
   if p[1][1]=p[2][1] then       -- horizontal pair
      -- trying to turn right at top
      if p[1][1]=1 and field[p[1][1]+1][p[1][2]]=0 and field[p[2][1]+1][p[2][2]]=0
            and field[p[1][1]][p[1][2]+1]=0 and field[p[1][1]+2][p[1][2]+1]=0 then
         erase_pair()
         p[1][2]=p[1][2]+1
         p[2][1]=p[2][1]+2
         p[2][2]=p[2][2]-1
         show_pair()
      elsif p[1][1]>1 and p[1][1]<rows then
         if field[p[1][1]-1][p[1][2]+1]=0 and field[p[1][1]+1][p[1][2]+1]=0  then
            erase_pair()
            p[1][1]=p[1][1]-1
            p[1][2]=p[1][2]+1
            p[2][1]=p[2][1]+1
            p[2][2]=p[2][2]-1
            show_pair()
         end if
      end if
   elsif p[1][2]>1 and p[1][2]<cols then  -- vertical pair
      if field[p[1][1]+1][p[1][2]+1]=0 and field[p[2][1]-1][p[2][2]-1]=0 then
         erase_pair()
         p[1][1]=p[1][1]+1
         p[1][2]=p[1][2]-1
         p[2][1]=p[2][1]-1
         p[2][2]=p[2][2]+1
         dummy=p[1][3]
         p[1][3]=p[2][3]
         p[2][3]=dummy
         show_pair()
      end if
   end if
end procedure

procedure collapse()
   integer i,j
   sequence s
   s=repeat(repeat(0,cols),rows)
   flag=false
   for r=1 to rows do      -- horizontal sweep
      i=1   j=2
      while j<=cols do
         while j<=cols and field[r][i] and field[r][i]=field[r][j] do
            j=j+1
         end while
         if j-i>3 then
            flag=true
            s[r][i..j-1]=1
         end if
         i=j
         j=j+1
      end while
   end for
   for c=1 to cols do      -- vertical sweep
      i=1   j=2
      while j<=rows do
         while j<=rows and field[i][c] and field[i][c]=field[j][c] do
            j=j+1
         end while
         if j-i>3 then
            flag=true
            for k=i to j-1 do
               s[k][c]=1
            end for
         end if
         i=j
         j=j+1
      end while
   end for
   if flag then
      for r=1 to rows do
         for c=1 to cols do
            if s[r][c] then
               erase_token(r,c)
               field[r][c]=0
               if seeds[r][c] then
                  seeds[r][c]=0
                  score=score+10
                  seed_count=seed_count-1
                  if seed_count=0 then
                     if level<8 then
                        level=level+1
                     end if
                     flag=false
                  end if
               else
                  score=score+1
               end if
               show_score()
            end if
         end for
      end for
   end if
end procedure

procedure tumble()
   integer i
   for r = rows-1 to 1 by -1 do
      for c = 1 to cols do
         if field[r][c] and seeds[r][c]=0 and field[r+1][c]=0 then
            i=r
            while field[i+1][c]=0 do
               erase_token(i,c)
               field[i+1][c]=field[i][c]
               field[i][c]=0
               i=i+1
               show_stone(i,c,field[i][c])
               beep(100*i,0.05)
            end while
         end if
      end for
   end for
end procedure

procedure meld()
   field[p[1][1]][p[1][2]]=p[1][3]
   show_stone(p[1][1],p[1][2],p[1][3])
   field[p[2][1]][p[2][2]]=p[2][3]
   show_stone(p[2][1],p[2][2],p[2][3])
   flag=true
   while flag do
      tumble()
      collapse()
   end while
   get_new_pair()
end procedure

procedure step()
   if field[p[1][1]+1][p[1][2]]=0 and field[p[2][1]+1][p[2][2]]=0 then
      erase_pair()
      p[1][1]=p[1][1]+1
      p[2][1]=p[2][1]+1
      show_pair()
   else
      meld()
   end if
end procedure

procedure drop()
   while field[p[1][1]+1][p[1][2]]=0 and field[p[2][1]+1][p[2][2]]=0 do
      erase_pair()
      p[1][1]=p[1][1]+1
      p[2][1]=p[2][1]+1
      show_pair()
   end while
   meld()
end procedure

procedure help()
   junk=save_image({90,165},{550,330})
   rect(4,1,{90,165},{550,330})
   fselect(wi12)
   fp[2..3]={1,1}
   ftc=15
   fx=100   fy=180
   fprint("Twins  "&#10E&"version 1.00  by  "&#10F&" Jiri Babor  "&#10E&"1997")
   fx=100   fy=206
   fprint("Four or more tokens of the "&#109&"same color "&#10E&" and next to each other in a row or")
   fx=100   fy=222
   fprint("a column are taken out. "&#109&"Ten "&#10E&"points are awarded for each removed ring,")
   fx=100   fy=238
   fprint("and only "&#109&" one "&#10E&"point for each solid disk. The next screen  will appear only")
   fx=100   fy=254
   fprint("when "&#109&" all rings "&#10E&"are eliminated. The game finishes when a new pair,")
   fx=100   fy=270
   fprint("previewed in the narrow window at the top, is blocked by accumulated")
   fx=100   fy=286
   fprint("tokens.")
   ftc=9
   fx=100   fy=310
   fprint("Press a key to continue ...")
   key=wait_key()
   display_image({90,165},junk)
end procedure

procedure pause()
   junk=save_image({240,240},{400,280})
   rect(5,1,{240,240},{400,280})
   fselect(mo28)
   ftc=15
   fy=248
   fcprint(240,400,"paused")
   key=wait_key()
   display_image({240,240},junk)
end procedure


-- main ------------------------------------------------------------------------

junk = graphics_mode(18)         -- 640x480x16

init_session()

while not aborted do             -- session loop
   init_game()
   while not finished and not aborted do  -- game loop
      sow()
      while not finished and not aborted and seed_count>0 do   -- level loop
         if time()-t>dt then
            t=time()
            step()
         end if
         key=get_key()
         if key=27 or key='q' then  -- Esc, 'q'
            aborted=true
         elsif key=32 then          -- space bar
            flip()
         elsif key='h' or key=315 then
            help()
         elsif key='p' then
            pause()
         elsif key=331 then
            go_left()
         elsif key=333 then
            go_right()
         elsif key=328 then         -- up arrow
            turn_clockwise()
         elsif key=397 then         -- ctrl up arrow: turn anticlockwise
            turn_clockwise()
            flip()
         elsif key=401 then         -- ctrl down arrow
            drop()
         elsif key=336 then         -- down arrow
            t=time()
            step()
         end if
      end while
   end while
end while

--key=wait_key()
junk=graphics_mode(-1)
